## boolector 1.5.118.6b56be4.121013

=== examples/Makefile ===
all:
	 for m in `find * -name makefile`; do d=`dirname $$m`; make -C $$d all; done
clean:
	 for m in `find * -name makefile`; do d=`dirname $$m`; make -C $$d clean; done
