## boolector 1.4.ffc2089.100608

=== debian/changelog ===
boolector (1.4.ffc2089.100608-1) unstable; urgency=low

  * Initial release (Closes: #584542)

 -- Michael Tautschnig <mt@debian.org>  Wed, 09 Jun 2010 00:16:01 +0200
