=== debian/control ===
Source: boolector
Section: science
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 5), picosat
Standards-Version: 3.8.4
Homepage: http://fmv.jku.at/boolector/

Package: boolector
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SMT solver for bit-vectors and arrays
 Boolector is an efficient SMT solver for the quantifier-free theory of
 bit-vectors in combination with the quantifier-free extensional theory of
 arrays.
