## boolector 1.5.118.6b56be4.121013

=== debian/changelog ===
boolector (1.5.118.6b56be4.121013-1build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:15:32 +0000

boolector (1.5.118.6b56be4.121013-1) unstable; urgency=low

  * New upstream release
  * Bumped Standards-Version to 3.9.3 (no changes)

 -- Michael Tautschnig <mt@debian.org>  Tue, 16 Oct 2012 13:01:32 +0100
