=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: boolector
 Section: science
 Priority: extra
-Maintainer: Michael Tautschnig <mt@debian.org>
-Build-Depends: debhelper (>= 5), picosat
-Standards-Version: 3.8.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Michael Tautschnig <mt@debian.org>
+Build-Depends: debhelper (>= 5)
+Standards-Version: 3.9.3
 Homepage: http://fmv.jku.at/boolector/
 
 Package: boolector
