=== debian/rules ===
--- 
+++ 
@@ -23,9 +23,11 @@
 	OPTFLAGS = -O
 endif
 
-makefile: configure
+makefile: configure lingeling/configure
 	dh_testdir
 	# Add here commands to configure the package.
+	cd lingeling ; ./configure
+	$(MAKE) -C lingeling
 	./configure
 
 build: build-stamp
