=== debian/watch ===
version=3
http://fmv.jku.at/boolector/boolector-(.*)-(.*)-(.*)\.tar\.gz
