=== test/CMakeLists.txt ===
# Boolector: Satisfiablity Modulo Theories (SMT) solver.
#
# Copyright (C) 2007-2021 by the authors listed in the AUTHORS file.
#
# This file is part of Boolector.
# See COPYING for more information on using this software.
#

find_package(GoogleTest REQUIRED)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/tests)

set(test_names
  aig
  aigvec
  arithmetic
  boolectornodemap
  bv
  comp
  exp
  hash
  inc
  inthash
  inthashmap
  lambda
  logic
  mc
  mem
  misc
  modelgen
  modelgensmt2
  nodemap
  normquant
  overflow
  parseerror
  prop
  propinv
  rotate
  queue
  satmgr
  shift
  smtaxioms
  sort
  stack
  unionfind
  util
)

foreach(test ${test_names})
  add_executable (test${test} test_${test}.cpp)
  target_include_directories(test${test} PRIVATE ${PROJECT_SOURCE_DIR}/test/new_test)
  target_link_libraries(test${test} boolector m)
  target_link_libraries(test${test} GTest::gtest_main)
  set_target_properties(test${test} PROPERTIES OUTPUT_NAME test${test} CXX_STANDARD 14)
  add_test(${test} ${CMAKE_BINARY_DIR}/bin/tests/test${test})
endforeach()

set(sat_testcases
"arraycond1.btor"
"arraycond10.btor"
"arraycond15.btor"
"arraycond16.btor"
"arraycond17.btor"
"arraycond2.btor"
"arraycond4.btor"
"const1.btor"
"constarray.smt2"
"ext1.btor"
"ext12.btor"
"ext14.btor"
"ext17.btor"
"ext20.btor"
"ext3.btor"
"ext4.btor"
"ext6.btor"
"ext8.btor"
"extarraywrite3sat.smt2"
"factor18446744073709551617const.btor"
"factor18446744073709551617xconst.btor"
"factor18446744073709551617yconst.btor"
"factor2209.btor"
"factor4294967295.btor"
"factor4294967297.btor"
"fifo32ia04k05.smt2"
"fifo32in04k05.smt2"
"invalidmodel1.smt2"
"invalidmodel2.smt2 -xl=0 -ml=0 -rwl=2"
"invalidmodel3.btor"
"issue96.smt2"
"lazyreadwritebug1.btor"
"lambda1.btor"
"lin0.btor"
"lin1.btor"
"lin2.btor"
"lin3.btor"
"lin4.btor"
"nestedfun1.smt2 -rwl 2"
"normaddneg0.btor"
"normaddneg1.btor"
"proxybug.btor"
"random1.btor"
"random1.btor2"
"random2.btor"
"random3.btor"
"random4.btor"
"read12.btor"
"read13.btor"
"read14.btor"
"read15.btor"
"read18.btor"
"read3.btor"
"redand3twice.btor"
"redor3.btor"
"regr3vl1.btor -rwl 0"
"regr3vl1.btor -rwl 1"
"regr3vl1.btor -rwl 2"
"regr3vl1.btor -rwl 3"
"regr3vl2.btor -rwl 0"
"regr3vl2.btor -rwl 1"
"regr3vl2.btor -rwl 2"
"regr3vl2.btor -rwl 3"
"regr3vl3.btor -rwl 0"
"regr3vl3.btor -rwl 1"
"regr3vl3.btor -rwl 2"
"regr3vl3.btor -rwl 3"
"regr3vl4.btor -rwl 0"
"regr3vl4.btor -rwl 1"
"regr3vl4.btor -rwl 2"
"regr3vl4.btor -rwl 3"
"regrbetacache1.btor -br all"
# currently broken since we don't allow to mix lambdas with arrays
#"regrbetacache2.btor -br all"
"regrbfs1.btor -rwl 0"
"regrbfs1.btor -rwl 1"
"regrbfs1.btor -rwl 2"
"regrbfs1.btor -rwl 3"
"regrcollectprem.btor"
"regrdomabst1.btor"
"regrdomabst2.btor"
"regrdomabst3.btor"
"regrdomabst4.btor"
"regrembeddedconstraint10.btor -rwl 0"
"regrembeddedconstraint10.btor -rwl 1"
"regrembeddedconstraint10.btor -rwl 2"
"regrembeddedconstraint10.btor -rwl 3"
"regrembeddedconstraint11.btor -rwl 0"
"regrembeddedconstraint11.btor -rwl 1"
"regrembeddedconstraint11.btor -rwl 2"
"regrembeddedconstraint11.btor -rwl 3"
"regrembeddedconstraint3.btor -rwl 0"
"regrembeddedconstraint3.btor -rwl 1"
"regrembeddedconstraint3.btor -rwl 2"
"regrembeddedconstraint3.btor -rwl 3"
"regrembeddedconstraint5.btor -rwl 0"
"regrembeddedconstraint5.btor -rwl 1"
"regrembeddedconstraint5.btor -rwl 2"
"regrembeddedconstraint5.btor -rwl 3"
"regrembeddedconstraint6.btor -rwl 0"
"regrembeddedconstraint6.btor -rwl 1"
"regrembeddedconstraint6.btor -rwl 2"
"regrembeddedconstraint6.btor -rwl 3"
"regrembeddedconstraint7.btor -rwl 0"
"regrembeddedconstraint7.btor -rwl 1"
"regrembeddedconstraint7.btor -rwl 2"
"regrembeddedconstraint7.btor -rwl 3"
"regrembeddedconstraint8.btor -rwl 0"
"regrembeddedconstraint8.btor -rwl 1"
"regrembeddedconstraint8.btor -rwl 2"
"regrembeddedconstraint8.btor -rwl 3"
"regrembeddedconstraint9.btor -rwl 0"
"regrembeddedconstraint9.btor -rwl 1"
"regrembeddedconstraint9.btor -rwl 2"
"regrembeddedconstraint9.btor -rwl 3"
"regrencparamapps.smt2"
"regrlemmaloop_embeddedconstraints.btor -rwl 1"
"regrmark1.btor -rwl 0"
"regrmark1.btor -rwl 1"
"regrmark1.btor -rwl 2"
"regrmark1.btor -rwl 3"
"regrmodel1.btor"
"regrmodel3.btor"
"regrmodel4.btor"
"regpicoprepsqrt4.btor"
"regprim11simp.btor"
"regrrwbinexpconcatzeroconst.btor"
"regrw8simp.btor"
"rol_same_bw.btor"
"ror_same_bw.btor"
"rw113.btor -rwl 0"
"rw1.btor"
"rw10.btor"
"rw11.btor"
"rw12.btor"
"rw13.btor"
"rw14.btor"
"rw15.btor"
"rw2.btor"
"rw3.btor"
"rw4.btor"
"rw5.btor"
"rw6.btor"
"rw7.btor"
"rw8.btor"
"rw9.btor"
"rw113.btor -rwl 1"
"rw114.btor -rwl 0"
"rw114.btor -rwl 1"
"rw121.btor -rwl 0"
"rw121.btor -rwl 1"
"rw122.btor -rwl 0"
"rw122.btor -rwl 1"
"rw132.btor -rwl 0"
"rw132.btor -rwl 1"
"rw133.btor -rwl 0"
"rw133.btor -rwl 1"
"rw134.btor -rwl 0"
"rw134.btor -rwl 3"
"rw135.btor -rwl 0"
"rw135.btor -rwl 3"
"rw137.btor -rwl 0"
"rw137.btor -rwl 3"
"rw138.btor -rwl 0"
"rw138.btor -rwl 3"
"rw139.btor -rwl 0"
"rw139.btor -rwl 3"
"rw140.btor -rwl 0"
"rw140.btor -rwl 3"
"rw141.btor -rwl 0"
"rw141.btor -rwl 3"
"rw142.btor -rwl 0"
"rw142.btor -rwl 3"
"rw143.btor -rwl 0"
"rw143.btor -rwl 3"
"rw148.btor -rwl 0"
"rw148.btor -rwl 3"
"rw153.btor -rwl 0"
"rw153.btor -rwl 3"
"rw157.btor"
"rw16.btor -rwl 0"
"rw16.btor -rwl 1"
"rw166.btor -rwl 1"
"rw167.btor -rwl 1"
"rw168.btor -rwl 1"
"rw169.btor -rwl 1"
"rw17.btor -rwl 0"
"rw17.btor -rwl 1"
"rw178.btor -rwl 3"
"rw179.btor -rwl 3"
"rw18.btor -rwl 0"
"rw18.btor -rwl 1"
"rw212.smt2 -rwl 3"
"rw216.smt2 -rwl 3"
"rw44.btor -rwl 0"
"rw44.btor -rwl 1"
"rw45.btor -rwl 0"
"rw45.btor -rwl 1"
"rw58.btor -rwl 0"
"rw58.btor -rwl 3"
"rw59.btor -rwl 0"
"rw59.btor -rwl 3"
"rwpropindexpluszero1.btor"
"rwpropindexpluszero1.btor -rwl 0"
"rwpropindexpluszero2.btor"
"rwpropindexpluszero2.btor -rwl 0"
"rwpropindexpluszero3.btor"
"rwpropindexpluszero3.btor -rwl 0"
"rwpropindexpluszero4.btor"
"rwpropindexpluszero4.btor -rwl 0"
"rwpropindexpluszero5.btor"
"rwpropindexpluszero5.btor -rwl 0"
"rwpropindexpluszero6.btor"
"rwpropindexpluszero6.btor -rwl 0"
"rwpropindexpluszero7.btor"
"rwpropindexpluszero7.btor -rwl 0"
"rwpropindexpluszero8.btor"
"rwpropindexpluszero8.btor -rwl 0"
"rwr1.btor -rwl 3 -br all"
"rww1.btor -rwl 3"
"sc12fuzzcheck2.smt2"
"slicesubst1.btor -rwl 0"
"slicesubst1.btor -rwl 2"
"sll_same_bw.btor"
"smt2pushpop0.smt2 -i"
"smtashr1.smt2"
"smtashr2.smt2"
"smtashr3.smt2"
"smtextarray1sat0.smt2"
"smtextarray1sat1.smt2"
"smtextarray2sat0.smt2"
"smtextarray2sat1.smt2"
"smtextarray2sat2.smt2"
"smtextarray2sat3.smt2"
"smtextarray3sat0.smt2"
"smtextarray3sat1.smt2"
"smtextarray3sat2.smt2"
"smtextarray3sat3.smt2"
"smtextarray3sat4.smt2"
"smtextarray3sat5.smt2"
"smtextarray3sat6.smt2"
"smtextarray3sat7.smt2"
"smtlshr1.smt2"
"smtlshr2.smt2"
"smtlshr3.smt2"
"smtrepeat.smt2"
"smtrotate.smt2"
"smtshl1.smt2"
"smtshl2.smt2"
"smtshl3.smt2"
"smtsignextend.smt2"
"smttrue.smt2"
"smtzeroextend.smt2"
"sqrt25.btor"
"sqrt4.btor"
"sqrt4295098369.btor"
"sqrt49.btor"
"sqrt9.btor"
"srl_same_bw.btor"
"substcyclic1.btor"
"substitute1.btor"
"substitute3.btor"
"substitute4.btor"
"substitute40.btor"
"substitute5.btor"
"swapmem002se.smt2"
"ultsubst1.btor -rwl 0"
"ultsubst1.btor -rwl 2"
"ultsubst2.btor -rwl 0"
"ultsubst2.btor -rwl 2"
"ultsubst3.btor -rwl 0"
"ultsubst3.btor -rwl 2"
"ultsubst4.btor -rwl 0"
"ultsubst4.btor -rwl 2"
"ultsubst5.btor -rwl 0"
"ultsubst5.btor -rwl 2"
"ultsubst6.btor -rwl 0"
"ultsubst6.btor -rwl 2"
"ultsubst7.btor -rwl 0"
"ultsubst7.btor -rwl 2"
"ultsubst8.btor -rwl 0"
"ultsubst8.btor -rwl 2"
"ultsubst9.btor -rwl 0"
"ultsubst9.btor -rwl 2"
"upprop1.btor"
"var1.btor"
"var2.btor"
"write11.btor"
"write12.btor"
"write15.btor"
"write18.btor"
"write19.btor"
"write20.btor"
"write5.btor"
"wchains002se.smt2"
)

set(unsat_testcases
"3vl1.btor -rwl 0"
"3vl1.btor -rwl 2"
"3vl2.btor -rwl 0"
"3vl2.btor -rwl 2"
"3vl3.btor -rwl 0"
"3vl3.btor -rwl 2"
"3vl4.btor -rwl 0"
"3vl4.btor -rwl 2"
"3vl5.btor -rwl 0"
"3vl5.btor -rwl 2"
"3vl6.btor -rwl 0"
"3vl6.btor -rwl 2"
"addnegmul1.btor"
"andopt1.btor"
"andopt10.btor"
"andopt11.btor"
"andopt12.btor"
"andopt13.btor"
"andopt14.btor"
"andopt15.btor"
"andopt16.btor"
"andopt17.btor"
"andopt2.btor"
"andopt3.btor"
"andopt4.btor"
"andopt5.btor"
"andopt6.btor"
"andopt7.btor"
"andopt8.btor"
"andopt9.btor"
"arraycond11.btor"
"arraycond12.btor"
"arraycond13.btor"
"arraycond14.btor"
"arraycond18.btor"
"arraycond3.btor"
"arraycond5.btor"
"arraycond6.btor"
"arraycond7.btor"
"arraycond8.btor"
"arraycond9.btor"
"arraycondconst.btor -rwl 0"
"arraycondconstaig.btor -rwl 0"
"binarysearch32s016.smt2"
"bubsort002un.smt2"
"const2.btor"
"countbits016.smt2"
"dec_rwl3.btor"
"dec_rwl0.btor -rwl 0"
"distri1.btor"
"distri2.btor"
"distri3.btor"
"distri4.btor"
"distri5.btor"
"distri6.btor"
"distri7.btor"
"distri8.btor"
"dubreva002ue.smt2"
"exactlyone.btor"
"ext10.btor"
"ext11.btor"
"ext13.btor"
"ext15.btor"
"ext16.btor"
"ext18.btor"
"ext19.btor"
"ext2.btor"
"ext21.btor"
"ext22.btor"
"ext23.btor"
"ext24.btor"
"ext25.btor"
"ext26.btor"
"ext27.btor"
"ext28.btor"
"ext29.btor"
"ext5.btor"
"ext7.btor"
"ext9.btor"
"extarraywrite1.btor"
"extarraywrite2.btor"
"extarraywrite3.smt2"
"fifo32bc04k05.smt2"
"gtewithsub.btor"
"hd1.btor -rwl 0"
"hd1.btor -rwl 1"
"hd10.btor -rwl 0"
"hd10.btor -rwl 1"
"hd11.btor -rwl 0"
"hd11.btor -rwl 1"
"hd12.btor -rwl 0"
"hd12.btor -rwl 1"
"hd13.btor -rwl 0"
"hd13.btor -rwl 1"
"hd14.btor -rwl 0"
"hd14.btor -rwl 1"
"hd15.btor -rwl 0"
"hd15.btor -rwl 1"
"hd16.btor -rwl 0"
"hd16.btor -rwl 1"
"hd17.btor -rwl 0"
"hd17.btor -rwl 1"
"hd18.btor -rwl 0"
"hd18.btor -rwl 1"
"hd19.btor"
"hd2.btor -rwl 0"
"hd2.btor -rwl 1"
"hd20.btor"
"hd21.btor"
"hd3.btor -rwl 0"
"hd3.btor -rwl 1"
"hd4.btor -rwl 0"
"hd4.btor -rwl 1"
"hd5.btor -rwl 0"
"hd5.btor -rwl 1"
"hd6.btor -rwl 0"
"hd6.btor -rwl 1"
"hd7.btor -rwl 0"
"hd7.btor -rwl 1"
"hd8.btor -rwl 0"
"hd8.btor -rwl 1"
"hd9.btor -rwl 0"
"hd9.btor -rwl 1"
"inc.btor"
"inc.btor -rwl 0"
"issue97.smt2"
"lambda2.btor"
"memcpy02.smt2"
"mulassoc4.smt2"
"mulassoc5.smt2"
"mulassoc6.smt2"
"nextpoweroftwo016.smt2"
"normaddneg2.btor"
"normaddneg3.btor"
"prim8bugreduced.btor"
"problem_130.smt2"
"random5.btor -rwl 0"
"random5.btor -rwl 1"
"read1.btor"
"read10.btor"
"read11.btor"
"read16.btor"
"read17.btor"
"read19.btor"
"read2.btor"
"read20.btor"
"read21.btor"
"read22.btor"
"read4.btor"
"read5.btor"
"read6.btor"
"read7.btor"
"read8.btor"
"read9.btor"
"regr-distinct.smt2"
"regrcalypto1.smt2"
"regrcalypto2.smt2"
"regrcalypto3.smt2"
"regrembeddedconstraint1.btor -rwl 0"
"regrembeddedconstraint1.btor -rwl 1"
"regrembeddedconstraint1.btor -rwl 2"
"regrembeddedconstraint1.btor -rwl 3"
"regrembeddedconstraint12.btor -rwl 0"
"regrembeddedconstraint12.btor -rwl 1"
"regrembeddedconstraint12.btor -rwl 2"
"regrembeddedconstraint12.btor -rwl 3"
"regrembeddedconstraint13.btor -rwl 0"
"regrembeddedconstraint13.btor -rwl 1"
"regrembeddedconstraint13.btor -rwl 2"
"regrembeddedconstraint13.btor -rwl 3"
"regrembeddedconstraint14.btor -rwl 0"
"regrembeddedconstraint14.btor -rwl 1"
"regrembeddedconstraint14.btor -rwl 2"
"regrembeddedconstraint14.btor -rwl 3"
"regrembeddedconstraint2.btor -rwl 0"
"regrembeddedconstraint2.btor -rwl 1"
"regrembeddedconstraint2.btor -rwl 2"
"regrembeddedconstraint2.btor -rwl 3"
"regrembeddedconstraint4.btor -rwl 0"
"regrembeddedconstraint4.btor -rwl 1"
"regrembeddedconstraint4.btor -rwl 2"
"regrembeddedconstraint4.btor -rwl 3"
"regrexpleak1.btor -rwl 0"
"regrexpleak1.btor -rwl 1"
"regrexpleak1.btor -rwl 2"
"regrexpleak1.btor -rwl 3"
"regrexpleak2.btor -rwl 0"
"regrexpleak2.btor -rwl 1"
"regrexpleak2.btor -rwl 2"
"regrexpleak2.btor -rwl 3"
"regrnormquant.smt2"
"regrmark2.btor -rwl 0"
"regrmark2.btor -rwl 1"
"regrmark2.btor -rwl 2"
"regrmark2.btor -rwl 3"
"regrmark3.btor -rwl 0"
"regrmark3.btor -rwl 1"
"regrmark3.btor -rwl 2"
"regrmark3.btor -rwl 3"
"regrmodel2.btor"
"regrpointerchasing1.btor"
"regsmod1.smt2"
"regsmtparselet.smt2"
"regsubslapd149921red.btor"
"rw100.btor -rwl 0"
"rw100.btor -rwl 1"
"rw101.btor -rwl 0"
"rw101.btor -rwl 1"
"rw102.btor -rwl 0"
