=== debian/changelog ===
boolector (3.2.4-1) unstable; urgency=medium

  * New upstream version
    Closes: #922877, #1043884
  * Maintain package in Debian Science team
    Closes: #1111926
  * Update Homepage
  * Fix watch file, version=5
  * debhelper-compat 13 (routine-update)
  * Remove old boilerplate from debian/rules (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Trim trailing whitespace.
  * d/rules: Switch to short dh
    Closes: #1119363
  * d/copyright: DEP5
  * Make sure package builds with CMake 4
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Prevent static linking

 -- Andreas Tille <tille@debian.org>  Fri, 30 Jan 2026 15:17:25 +0100

boolector (1.5.118.6b56be4.121013-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * mkconfig: Do not embed architecture of running kernel.
    (Closes: #1023886)

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 11 Nov 2022 20:56:12 -0800

boolector (1.5.118.6b56be4.121013-1.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Chris Lamb ]
  * Do not embed kernel version and hostname. Use SOURCE_DATE_EPOCH for
    timestamp.  (Closes: #8311031)

  [ Vagrant Cascadian ]
  * debian/rules: Use C.UTF-8 locale for building to ensure reproducible builds.

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 10 Nov 2022 13:35:53 -0800

boolector (1.5.118.6b56be4.121013-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/compat: 5 -> 7. (Closes: #965441)
  * debian/rules: Add build-{arch,indep}. (Closes: #999261)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Dec 2021 21:53:28 +0200
