=== debian/control ===
Source: boolector
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Michael Tautschnig <mt@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Build-Depends: debhelper-compat (= 13),
               cmake,
               libbtor2parser-dev,
               minisat,
               zlib1g-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/boolector
Vcs-Git: https://salsa.debian.org/science-team/boolector.git
Homepage: https://boolector.github.io/

Package: boolector
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SMT solver for bit-vectors and arrays
 Boolector is an efficient SMT solver for the quantifier-free theory of
 bit-vectors in combination with the quantifier-free extensional theory of
 arrays.
