=== debian/watch ===
Version: 5

Template: Github
Owner: Boolector
Project: boolector
